<!-- ## Shock -->


Following @leveque1992numerical and beginning at the Rankine-Hugoniot condition, the following system of equations is obtained:

$$
\begin{aligned}
\tilde{m}-\hat{m} &=s(\tilde{\rho}-\hat{\rho}) \\
\left(\tilde{m}^{2} / \tilde{\rho}+a^{2} \tilde{\rho}\right)-\left(\hat{m}^{2} / \hat{\rho}+a^{2} \hat{\rho}\right) &=s(\tilde{m}-\hat{m})
\end{aligned}
$$

![Graphical solution of the isothermal Riemann problem](../img/p1-locus.png)


$$
\rho_{1} m_{0} / \rho_{0}-a \sqrt{\rho_{1} / \rho_{0}}\left(\rho_{1}-\rho_{0}\right)=\rho_{1} m_{2} / \rho_{2}+a \sqrt{\rho_{1} / \rho_{2}}\left(\rho_{1}-\rho_{2}\right)
$$

$$
\left(\frac{a}{\sqrt{\rho_{2}}}+\frac{a}{\sqrt{\rho_{0}}}\right) z^{2}+\left(\frac{m_{2}}{\rho_{2}}-\frac{m_{0}}{\rho_{0}}\right) z-a\left(\sqrt{\rho_{2}}+\sqrt{\rho_{0}}\right)=0
$$

Plugging in the specified values for $q_0$ and $q_2$ yields the following coefficients:

$$
\begin{aligned}
\frac{a}{\sqrt{\rho_{2}}}+\frac{a}{\sqrt{\rho_{0}}} = 2\\
\frac{m_{2}}{\rho_{2}}-\frac{m_{0}}{\rho_{0}} = -3\\
a\left(\sqrt{\rho_{2}}+\sqrt{\rho_{0}}\right) = -2
\end{aligned}
$$

This yields the following roots:

$$
\rho_1 = \left\{\frac{1}{4}, 4\right\} \\
$$

$$
m_1 =\rho_{m} m_{r} / \rho_{r}+a \sqrt{\rho_{m} / \rho_{r}}\left(\rho_{m}-\rho_{r}\right) \\
$$

 <!-- = \left\{\frac{9}{8}, 6\right\} -->

$$
\boxed{q_1 = \begin{pmatrix}4 \\ 6\end{pmatrix}}
$$


>In each region $i=0,1,2$, compute the characteristic speeds, which are the eigenvalues $\lambda_{i1}$ and $\lambda_{i2}$ of the Jacobian $J_i=DF(q_i)$. Also compute the fluid velocities $v_i$.  

$$
DF(q_i)=\begin{pmatrix}
0 & 1 \\
a^{2}-m_i^{2} / \rho_i^{2} & 2 m_i / \rho_i
\end{pmatrix}
$$


### State $i=0$

$$
DF(q_0) = \begin{pmatrix}0 & 1\\ -8 & 6\end{pmatrix}
$$

$$
\lambda = \{2,4\}
$$

$$
\mathbf{Q} = \begin{pmatrix}
-0.4472136 & -0.24253563\\
-0.89442719 & -0.9701425 
\end{pmatrix}
$$

$$
v_0 = 3
$$


### State $i=1$

$$
\lambda_1 = \{1/2, 5/2\}
$$

$$
\mathbf{Q} = \begin{pmatrix}
-0.89442719& -0.37139068 \\
-0.4472136 & -0.92847669
\end{pmatrix}
$$

$$
v_1 = 3/2
$$

$$
\dot s_1 = 1
$$

### State $i=2$

$$
DF(q_2) = \begin{pmatrix} 0 & 1 \\ 1 & 0 \end{pmatrix}
$$

$$
\lambda_2 = (1,-1)
$$

$$
\mathbf{Q} = \frac{1}{\sqrt{2}}\begin{pmatrix}1 & -1 \\ 1 & 1\end{pmatrix}
$$

$$
v_2 = 0
$$

$$
\dot s_2 = 2
$$

<!-- ## Rarefaction -->

<!-- (8.22) -->

<!--
$$
\rho_{m}=\sqrt{\rho_{l} \rho_{r}} \exp \left(\frac{1}{2 a}\left(\frac{m_{l}}{\rho_{l}}-\frac{m_{r}}{\rho_{r}}\right)\right) .
$$

$$
=\rho_{m} m_{r} / \rho_{r}+a \sqrt{\rho_{m} / \rho_{r}}\left(\rho_{m}-\rho_{r}\right)
$$

-->

